#!/usr/bin/perl
use strict;
use warnings;

my %node;
my %link;

$node{"00000001"} = 0;
$node{"00000002"} = 0;
$node{"00000003"} = 0;
$node{"00000004"} = 0;
$node{"00000005"} = 0;

$link{"00000001,00000002"} = 0;
$link{"00000001,00000003"} = 0;
$link{"00000001,00000004"} = 0;
$link{"00000002,00000003"} = 0;
$link{"00000002,00000004"} = 0;
$link{"00000003,00000005"} = 0;

my %bet_all_node;

foreach my $n1 (keys %node){
            
    my %distance;
    my %weight;
    my $d = 0; # distance to check
    $distance{$n1} = 0;
    $weight{$n1} = 1;
            
    while(1){
        my $found = 0;
        foreach my $n2 (keys %node){
            !exists($distance{$n2}) and next;
            $distance{$n2} != $d and next;
            $found = 1;
                    
            foreach my $link_key (keys %link){
                my $from = substr($link_key,0, 8); 
                my $to   = substr($link_key,9,17); 
                if($from == $n2){
                     if(!exists($distance{$to})){
                          $distance{$to} = $d + 1;
                          $weight{$to} = $weight{$from};
                     }elsif($distance{$to} == $d + 1){
                          $weight{$to} += $weight{$from};
                     }
                }elsif($to == $n2){
                     if(!exists($distance{$from})){
                          $distance{$from} = $d + 1;
                          $weight{$from} = $weight{$to};
                     }elsif($distance{$from} == $d + 1){
                          $weight{$from} += $weight{$to};
                     }
                }
            }                    
        }
        $found == 0 and last;
        $d++;
    }
            
    # betweennes of the leaves
    my %bet_node; 
    my %bet_link;
    my %count;
    foreach my $link_key (keys %link){
        $count{substr($link_key,0, 8)}++;
        $count{substr($link_key,9,17)}++;
    }
    foreach(keys %count){
        ($count{$_} == 1 and $_ != $n1) and $bet_node{$_} = 1;
    }
           
    # betweeness of others
    while($d >= 0){
        foreach my $distance_key (keys %distance){
            $distance{$distance_key} != $d and next;
            exists($bet_node{$distance_key}) and $bet_node{$distance_key} ==  1 and next; # skip leaves
            $bet_node{$distance_key} = $distance_key == $n1 ? 0 : 1;
                     
            foreach my $link_key (keys %link){
                my $from = substr($link_key,0, 8); 
                my $to   = substr($link_key,9,17); 
                if($from == $distance_key and $distance{$to} == ($distance{$from} + 1) ){
                    my $val = $bet_node{$to} * $weight{$from} / $weight{$to};
                    $bet_node{$from}     += $val;
                }elsif($to == $distance_key and $distance{$from} == ($distance{$to} + 1) ){
                    my $val = $bet_node{$from} * $weight{$to} / $weight{$from};
                    $bet_node{$to}       += $val;
                }
            }
        }
        $d--;
    }
    foreach(keys %bet_node){ $bet_all_node{$_} += $bet_node{$_}; }
}

foreach(sort keys %bet_all_node){ print "node:$_ betweenness:$bet_all_node{$_}\n"; }